/*  Solutie 100 puncte
    Complexitate: O(m + n * n)
    prof. Constantin Galatan
*/
#include <iostream>
#include <fstream>
#include <vector>
using namespace std;

const int DIM = 1501;
ifstream fin("pseudobil.in");
ofstream fout("pseudobil.out");

typedef unsigned short M[2 * DIM][DIM];
M su, sd, pu, pd; // sec up, sec down, princ up, princ down
M a, b;           // a[d][j] = 1 daca pe diagonala secundara d si coloana j este 1, b - acelasi lucru pentru diagonala principala d
int m, n, K, L, D,  T, n1, n2;
unsigned short sc[DIM], ss[DIM], s[DIM];      // sume partiale pe coloane, suma dreptunghiului pana la col j
unsigned short sp1[DIM * 2], sp2[DIM * 2];    // suma pe diagonala curenta pana la coloana j

int main()
{
    fin >> T >> n >> K >> D;
    if ( T == 1 )  // rezolv numai cerinta 1)
    {
        int nr = D - 1;
        n1 = nr;
        while ( true )
        {
            nr -=2;
            if ( nr < 0 ) break;
            n1 += 2 * nr;
        }
        fout << n1 << '\n';
    }
    else // rezolv numai cerinta 2)
    {
        L = D / 2 + 1;
        int d;
        int x, y;
        for ( int i = 0; i < K; ++i )
        {
            fin >> x >> y;
            b[n + y - x][y] = 1;
            a[x + y - 1][y] = 1;
            s[y]++;
        }

        for ( int j = 1; j <=  n; ++j )
            ss[j] = ss[j - 1] + s[j];

        for ( int d = 1; d < 2 * n; ++d )
        {
            for (int j = 0; j <= n; ++j )
                sp1[j] = 0, sp2[j] = 0;

            for ( int j = max(d - n + 1, 1); j <= min(d, n) ; ++j )
            {
                sp1[j] = sp1[j - 1] + a[d][j];
                su[d][j] = su[d - 1][j] + sp1[j];
                if ( j >= d ) su[d][j] += su[d - 1][j - 1];
                sd[d][j] = ss[j] - su[d][j] + sp1[j];

                sp2[j] = sp2[j - 1] + b[d][j];
                pd[d][j] = pd[d - 1][j] + sp2[j];
                if ( j >= d ) pd[d][j] += pd[d - 1][j - 1];

                pu[d][j] = ss[j] - pd[d][j] + sp2[j];
            }

        }

        int A, B, C, D, E, F;
        fin >> m;

        for ( int i = 0; i < m; ++i )
        {
            fin >> x >> y;

            A = ss[y - L]; B = K - ss[y + L - 1];
            if ( y > x + y - 2 )
                C = su[x + y - 2][y - 1];
            else
                C = su[x + y - 2][y];
            C -= su[x + y - 2][y - L];
            D = pu[n - x + y + 1][y + L - 1] - pu[n - x + y + 1][y];
            int X = x + 2 * (L - 1);
            if ( y > n - X + y  -  1)
                E = pd[n - X + y  -  1][y - 1];
            else
                E = pd[n - X + y  -  1][y];
            E -= pd[n - X + y   -1][y - L];
            F = sd[X + y   ][y + L - 1] - sd[X + y ][y];
            n2 = K - (A + B + C + D + E + F);
            fout << n2 << '\n';
        }
    }
    fin.close();
    fout.close();
    return 0;
}

